%% DA
% How to read the variables names? It is simple:
% DA_i_transformation_j_distribution, where
% i (0 or 1) - dynamic choice
% j (0 or 1) - MC if 1, hist. if 0
close all
DA_0__0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
DA_0__1_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
DA_0_asinh_0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value',  'prediction');
DA_0_asinh_1_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
DA_0__0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
DA_0__1_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
DA_0_asinh_0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
DA_0_asinh_1_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
DA_0__0_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
DA_0__1_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
DA_0_asinh_0_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_PL_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value',  'prediction');
DA_0_asinh_1_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_PL_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
DA_0__0_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
DA_0__1_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
DA_0_asinh_0_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_PL_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
DA_0_asinh_1_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_PL_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
%% collecting models PS and their labels in a list
models_list = {DA_0__0_g.pinball, DA_0__1_g.pinball,... % gaussian GARCH(1,1)
    DA_0_asinh_0_g.pinball, DA_0_asinh_1_g.pinball,...
    DA_0__0_t.pinball, DA_0__1_t.pinball,... % t-Student GARCH(1,1,)
    DA_0_asinh_0_t.pinball, DA_0_asinh_1_t.pinball,...
    DA_0__0_g_GJR.pinball, DA_0__1_g_GJR.pinball,... % gaussian GARCH(1,1)
    DA_0_asinh_0_g_GJR.pinball, DA_0_asinh_1_g_GJR.pinball,...
    DA_0__0_t_GJR.pinball, DA_0__1_t_GJR.pinball,... % t-Student GARCH(1,1,)
    DA_0_asinh_0_t_GJR.pinball, DA_0_asinh_1_t_GJR.pinball,...
    DA_0__0_g.pinball_no_garch,... % without GARCH hist.
    DA_0__1_g.pinball_no_garch,... % without GARCH MC gaussian
    DA_0__1_t.pinball_no_garch,... % without GARCH MC t-Student
    DA_0_asinh_0_g.pinball_no_garch,... % without GARCH hist. asinh
    DA_0_asinh_1_g.pinball_no_garch,... % without GARCH MC gaussian asinh
    DA_0_asinh_1_t.pinball_no_garch}; % without GARCH MC t-Student asinh
labels = {'gaussian GARCH(1,1) hist.', 'gaussian GARCH(1,1) MC',...
    'gaussian GARCH(1,1) hist. asinh', 'gaussian GARCH(1,1) MC asinh',...
    't-Student GARCH(1,1) hist.', 't-Student GARCH(1,1) MC',...
    't-Student GARCH(1,1) hist. asinh', 't-Student GARCH(1,1) MC asinh',...
    'gaussian GJRGARCH(1,1) hist.', 'gaussian GJRGARCH(1,1) MC',...
    'gaussian GJRGARCH(1,1) hist. asinh', 'gaussian GJRGARCH(1,1) MC asinh',...
    't-Student GJRGARCH(1,1) hist.', 't-Student GJRGARCH(1,1) MC',...
    't-Student GJRGARCH(1,1) hist. asinh', 't-Student GJRGARCH(1,1) MC asinh',...
    'ARX hist.', 'gaussian ARX MC',...
    't-Student ARX MC', 'ARX hist. asinh',...
    'gaussian ARX MC asinh', 't-Student ARX MC asinh'
    };
%% PS means taken time wise vs quantiles
fignum = 1;
quantiles = 0.01:0.01:0.99;
% please change x in for hour = 'x' to range or other hour to see results
for hour = 1:24
    figure(fignum)
    plotbrowser('on')
    hold on
    for m = 1:length(models_list)
        plot(quantiles, squeeze(mean(models_list{m}(hour, :, :), 2)))
    end
    hold off
    legend(labels, 'Location', 'best')
    fignum = fignum + 1;
end
%% PS means taken quantile wise and represented hourly
figure(fignum)
plotbrowser('on')
hold on
for m = 1:length(models_list)
    plot(mean(mean(models_list{m}(:, :, :), 2), 3))
end
hold off
legend(labels, 'Location', 'best')
fignum = fignum + 1;
%% PS means taken time wise hourly for 5, 10, 25, 50, 75, 90 and 95 percentile
for q = [5, 10, 25, 50, 75, 90, 95]
    figure(fignum)
    plotbrowser('on')
    hold on
    for m = 1:length(models_list)
        plot(mean(models_list{m}(:, :, q), 2))
    end
    hold off
    legend(labels, 'Location', 'best')
    title(num2str(quantiles(q)))
    fignum = fignum + 1;
end
%% PS D--M tests aggregated
close all
addpath('Functions')
alpha = 0.1;
% summing over 24 hours
count_matrice = zeros([length(models_list), length(models_list)]);
for i = 1:length(models_list)
    for j = 1:length(models_list)
        if i == j
            count_matrice(i,j) = NaN;
        end
    end
end
for hour = 1:24
    pvalmatyrice = ones([length(models_list), length(models_list)]);
    for m = 1:length(models_list)
        for n = 1:length(models_list)
            [DM, p] = dmtest(mean(models_list{m}(hour, :, :), 3)', mean(models_list{n}(hour, :, :), 3)');
            pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
        end
    end
    count = pvalmatyrice < alpha;
    count_matrice = count_matrice + count;
end
xvalues = labels;
yvalues = labels;
figure(fignum)
h = heatmap(xvalues, yvalues, count_matrice);
h.FontSize = 6;
s = struct(h);
s.XAxis.TickLabelRotation = 90;  % vertical
caxis([0 24])
fignum = fignum + 1;
%% PS D--M test for chosen quantiles
for q = [5, 10, 25, 50, 75, 90, 95]
    % summing over 24 hours
    count_matrice = zeros([length(models_list), length(models_list)]);
    for i = 1:length(models_list)
        for j = 1:length(models_list)
            if i == j
                count_matrice(i,j) = NaN;
            end
        end
    end
    for hour = 1:24
        pvalmatyrice = ones([length(models_list), length(models_list)]);
        for m = 1:length(models_list)
            for n = 1:length(models_list)
                [DM, p] = dmtest(models_list{m}(hour, :, q)', models_list{n}(hour, :, q)');
                pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
            end
        end
        count = pvalmatyrice < alpha;
        count_matrice = count_matrice + count;
    end
    xvalues = labels;
    yvalues = labels;
    figure(fignum)
    h = heatmap(xvalues, yvalues, count_matrice);
    h.FontSize = 6;
    s = struct(h);
    s.XAxis.TickLabelRotation = 90;  % vertical
    caxis([0 24])
    fignum = fignum + 1;
    title(['D--M, quantile ', num2str(quantiles(q))])
    fignum = fignum + 1;
end
%% MAE
% curve
lin_models_list = {DA_0_asinh_0_g, DA_0__0_g};
labels = {'ARX asinh', 'ARX'};
figure(fignum)
plotbrowser('on')
for m = 1:length(lin_models_list)
    plot(lin_models_list{m}.mae_hourly)
    hold on
end
legend(labels)
hold off
fignum = fignum + 1;
%% RMSE
% curve
lin_models_list = {DA_0_asinh_0_g, DA_0__0_g};
labels = {'ARX asinh', 'ARX'};
figure(fignum)
plotbrowser('on')
for m = 1:length(lin_models_list)
    plot(lin_models_list{m}.rmse_hourly)
    hold on
end
legend(labels)
hold off
fignum = fignum + 1;
%% D--M for point forecast errors ('RMSE' type)
% summing over 24 hours
alpha = 0.1;
count_matrice = zeros([length(lin_models_list), length(lin_models_list)]);
for i = 1:length(lin_models_list)
    for j = 1:length(lin_models_list)
        if i == j
            count_matrice(i,j) = NaN;
        end
    end
end
for hour = 1:24
    pvalmatyrice = ones([length(lin_models_list), length(lin_models_list)]);
    for m = 1:length(lin_models_list)
        for n = 1:length(lin_models_list)
            e_1 = lin_models_list{m}.real_value(hour, :) - lin_models_list{m}.prediction(hour, :);
            e_2 = lin_models_list{n}.real_value(hour, :) - lin_models_list{n}.prediction(hour, :);
            [DM, p] = dmtest(e_1', e_2');
            pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
        end
    end
    count = pvalmatyrice < alpha;
    count_matrice = count_matrice + count;
end
xvalues = labels;
yvalues = labels;
figure(fignum)
h = heatmap(xvalues, yvalues, count_matrice);
h.FontSize = 6;
s = struct(h);
s.XAxis.TickLabelRotation = 90;  % vertical
caxis([0 24])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% ID
ID_0__0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_ID_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__1_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_ID_model_7_transformation__dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
ID_0_asinh_0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value',  'prediction');
ID_0_asinh_1_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_ID_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
ID_0__0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_ID_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
ID_0__1_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_ID_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
ID_0_asinh_0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
ID_0_asinh_1_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_ID_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
%% collecting models PS and their labels in a list
models_list = {ID_0__0_g.pinball, ID_0__1_g.pinball,... % gaussian GARCH(1,1)
    ID_0_asinh_0_g.pinball, ID_0_asinh_1_g.pinball,...
    ID_0__0_t.pinball, ID_0__1_t.pinball,... % t-Student GARCH(1,1,)
    ID_0_asinh_0_t.pinball, ID_0_asinh_1_t.pinball,...
    ID_0__0_g.pinball_no_garch,... % without GARCH hist.
    ID_0__1_g.pinball_no_garch,... % without GARCH MC gaussian
    ID_0__1_t.pinball_no_garch,... % without GARCH MC t-Student
    ID_0_asinh_0_g.pinball_no_garch,... % without GARCH hist. asinh
    ID_0_asinh_1_g.pinball_no_garch,... % without GARCH MC gaussian asinh
    ID_0_asinh_1_t.pinball_no_garch}; % without GARCH MC t-Student asinh
labels = {'gaussian GARCH(1,1) hist.', 'gaussian GARCH(1,1) MC',...
    'gaussian GARCH(1,1) hist. asinh', 'gaussian GARCH(1,1) MC asinh',...
    't-Student GARCH(1,1) hist.', 't-Student GARCH(1,1) MC',...
    't-Student GARCH(1,1) hist. asinh', 't-Student GARCH(1,1) MC asinh',...
    'ARX hist.', 'gaussian ARX MC',...
    't-Student ARX MC', 'ARX hist. asinh',...
    'gaussian ARX MC asinh', 't-Student ARX MC asinh'
    };
%% PS means taken time wise vs quantiles
fignum = 1;
quantiles = 0.01:0.01:0.99;
% please change x in for hour = 'x' to range or other hour to see results
for hour = 1:24
    figure(fignum)
    plotbrowser('on')
    hold on
    for m = 1:length(models_list)
        plot(quantiles, squeeze(mean(models_list{m}(hour, :, :), 2)))
    end
    hold off
    legend(labels, 'Location', 'best')
    fignum = fignum + 1;
end
%% PS means taken quantile wise and represented hourly
figure(fignum)
plotbrowser('on')
hold on
for m = 1:length(models_list)
    plot(mean(mean(models_list{m}(:, :, :), 2), 3))
end
hold off
legend(labels, 'Location', 'best')
fignum = fignum + 1;
%% PS means taken time wise hourly for 5, 10, 25, 50, 75, 90 and 95 percentile
for q = [5, 10, 25, 50, 75, 90, 95]
    figure(fignum)
    plotbrowser('on')
    hold on
    for m = 1:length(models_list)
        plot(mean(models_list{m}(:, :, q), 2))
    end
    hold off
    legend(labels, 'Location', 'best')
    title(num2str(quantiles(q)))
    fignum = fignum + 1;
end
%% PS D--M tests aggregated
close all
addpath('Functions')
alpha = 0.1;
% summing over 24 hours
count_matrice = zeros([length(models_list), length(models_list)]);
for i = 1:length(models_list)
    for j = 1:length(models_list)
        if i == j
            count_matrice(i,j) = NaN;
        end
    end
end
for hour = 1:24
    pvalmatyrice = ones([length(models_list), length(models_list)]);
    for m = 1:length(models_list)
        for n = 1:length(models_list)
            [DM, p] = dmtest(mean(models_list{m}(hour, :, :), 3)', mean(models_list{n}(hour, :, :), 3)');
            pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
        end
    end
    count = pvalmatyrice < alpha;
    count_matrice = count_matrice + count;
end
xvalues = labels;
yvalues = labels;
figure(fignum)
h = heatmap(xvalues, yvalues, count_matrice);
h.FontSize = 6;
s = struct(h);
s.XAxis.TickLabelRotation = 90;  % vertical
caxis([0 24])
fignum = fignum + 1;
%% PS D--M test for chosen quantiles
for q = [5, 10, 25, 50, 75, 90, 95]
    % summing over 24 hours
    count_matrice = zeros([length(models_list), length(models_list)]);
    for i = 1:length(models_list)
        for j = 1:length(models_list)
            if i == j
                count_matrice(i,j) = NaN;
            end
        end
    end
    for hour = 1:24
        pvalmatyrice = ones([length(models_list), length(models_list)]);
        for m = 1:length(models_list)
            for n = 1:length(models_list)
                [DM, p] = dmtest(models_list{m}(hour, :, q)', models_list{n}(hour, :, q)');
                pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
            end
        end
        count = pvalmatyrice < alpha;
        count_matrice = count_matrice + count;
    end
    xvalues = labels;
    yvalues = labels;
    figure(fignum)
    h = heatmap(xvalues, yvalues, count_matrice);
    h.FontSize = 6;
    s = struct(h);
    s.XAxis.TickLabelRotation = 90;  % vertical
    caxis([0 24])
    fignum = fignum + 1;
    title(['D--M, quantile ', num2str(quantiles(q))])
    fignum = fignum + 1;
end
%% MAE
% curve
lin_models_list = {ID_0_asinh_0_g, ID_0__0_g};
labels = {'ARX asinh', 'ARX'};
figure(fignum)
plotbrowser('on')
for m = 1:length(lin_models_list)
    plot(lin_models_list{m}.mae_hourly)
    hold on
end
legend(labels)
hold off
fignum = fignum + 1;
%% RMSE
% curve
lin_models_list = {ID_0_asinh_0_g, ID_0__0_g};
labels = {'ARX asinh', 'ARX'};
figure(fignum)
plotbrowser('on')
for m = 1:length(lin_models_list)
    plot(lin_models_list{m}.rmse_hourly)
    hold on
end
legend(labels)
hold off
fignum = fignum + 1;
%% D--M for point forecast errors ('RMSE' type)
% summing over 24 hours
alpha = 0.1;
count_matrice = zeros([length(lin_models_list), length(lin_models_list)]);
for i = 1:length(lin_models_list)
    for j = 1:length(lin_models_list)
        if i == j
            count_matrice(i,j) = NaN;
        end
    end
end
for hour = 1:24
    pvalmatyrice = ones([length(lin_models_list), length(lin_models_list)]);
    for m = 1:length(lin_models_list)
        for n = 1:length(lin_models_list)
            e_1 = lin_models_list{m}.real_value(hour, :) - lin_models_list{m}.prediction(hour, :);
            e_2 = lin_models_list{n}.real_value(hour, :) - lin_models_list{n}.prediction(hour, :);
            [DM, p] = dmtest(e_1', e_2');
            pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
        end
    end
    count = pvalmatyrice < alpha;
    count_matrice = count_matrice + count;
end
xvalues = labels;
yvalues = labels;
figure(fignum)
h = heatmap(xvalues, yvalues, count_matrice);
h.FontSize = 6;
s = struct(h);
s.XAxis.TickLabelRotation = 90;  % vertical
caxis([0 24])
fignum = fignum + 1;
