% this file generates plots of correlation between OOS residues from
% ID and DA markets
OOS_PL_DA_0__1_t = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'residua');
OOS_PL_ID_0_asinh1_1_t = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_PL_ID_model_7_transformation_asinh1_dynamic_choice_0_mc_1_dist_t.mat',...
    'residua');
Correlation = ones([24, size(OOS_PL_ID_0_asinh1_1_t.residua, 3)]) .*-999;
P_values = ones([24, size(OOS_PL_ID_0_asinh1_1_t.residua, 3)]) .*-999;
fignum = 1;
for h = 1:24
    for i = 1:size(OOS_PL_ID_0_asinh1_1_t.residua, 3)
        [Correlation(h, i), P_values(h, i)] = corr(OOS_PL_ID_0_asinh1_1_t.residua(h, :, i)', OOS_PL_DA_0__1_t.residua(h, :, i)');
    end
    figure(fignum)
    subplot(2,1,1)
    plot(Correlation(h, :))
    title("Pearson correlation")
    ylim([0,1])
    subplot(2,1,2)
    plot(P_values(h,:))
    title("p-values")
    fignum = fignum + 1;
end
