function sstd = semistd(X, std_sign)
    Y = X - mean(X);
    if std_sign == 1
        above_mean = Y(Y > 0);
        sstd = sqrt((1 / (length(above_mean) - 1)) * sum(above_mean .^ 2));
    elseif std_sign == -1
        below_mean = Y(Y <= 0);
        sstd = sqrt((1 / (length(below_mean) - 1)) * sum(below_mean .^ 2));
    end
end
