addpath('Functions')

model_DA = 'GARCH';
model_ID = 'GARCH';
transformation_DA = 'asinh';
transformation_ID = 'asinh';
dist_ID = 'g';
dist_DA = 'g';
w = 0:0.01:1;
IS_GE_DA = load(['../../../Data_MATLAB_Drive/Data/', model_DA, '_simulation_results_GE_DA_model_7_transformation_', transformation_DA, '_dynamic_choice_0_mc_0_dist_', dist_DA, '.mat'],...
    'samples', 'real_value');
IS_GE_ID = load(['../../../Data_MATLAB_Drive/Data/', model_ID, '_simulation_results_GE_ID_model_7_transformation_', transformation_ID, '_dynamic_choice_0_mc_0_dist_', dist_ID, '.mat'],...
    'samples', 'real_value');
%%
constant_weights_plots(IS_GE_ID, IS_GE_DA, w, 1:24)
%% investigation
XDates = datetime(2017,1,1):datetime(2020,12,31);
for h = 1:24
    figure(h)
    subplot(2,1,1)
    plot(XDates(374:end), IS_GE_DA.real_value(h, :))
    title(['DA prices, hour ', num2str(h)])
    subplot(2,1,2)
    plot(XDates(374:end), IS_GE_ID.real_value(h, :))
    title(['ID prices, hour ', num2str(h)])
end