addpath('Functions')

model_DA = 'GARCH';
model_ID = 'GARCH';
transformation_DA = '';
transformation_ID = '';
dist_ID = 't';
dist_DA = 't';
w = 0:0.01:1;
IS_PL_DA = load(['../../../Data_MATLAB_Drive/Data/', model_DA, '_simulation_results_PL_DA_model_7_transformation_', transformation_DA, '_dynamic_choice_0_mc_0_dist_', dist_DA, '.mat'],...
    'samples', 'real_value', 'prediction', 'quantiles');
IS_PL_ID = load(['../../../Data_MATLAB_Drive/Data/', model_ID, '_simulation_results_PL_ID_model_7_transformation_', transformation_ID, '_dynamic_choice_0_mc_0_dist_', dist_ID, '.mat'],...
    'samples', 'real_value', 'prediction', 'quantiles');
%%
constant_weights_plots(IS_PL_ID, IS_PL_DA, w, 1:24)

%% investigation
XDates = datetime(2017,1,1):datetime(2020,12,31);
for h = 1:24
    figure(h)
    subplot(2,1,1)
    plot(XDates(374:end), IS_PL_DA.real_value(h, :))
    hold on
    plot(XDates(374:end), IS_PL_DA.prediction(h,:))
    plot(XDates(374:end), IS_PL_DA.quantiles(h, :, 1), '--')
    plot(XDates(374:end), IS_PL_DA.quantiles(h, :, end), '--')
    legend("Data", "Prediction", "0.05 GARCH", "0.95 GARCH")
    title(['DA prices, hour ', num2str(h)])
    hold off
    subplot(2,1,2)
    plot(XDates(374:end), IS_PL_ID.real_value(h, :))
    hold on
    plot(XDates(374:end), IS_PL_ID.prediction(h,:))
    plot(XDates(374:end), IS_PL_ID.quantiles(h, :, 1), '--')
    plot(XDates(374:end), IS_PL_ID.quantiles(h, :, end), '--')
    legend("Data", "Prediction", "0.05 GARCH", "0.95 GARCH")
    title(['ID prices, hour ', num2str(h)])
    hold off
end