% this file generates plots of correlation between IS residues from
% ID and DA markets
close all
IS_PL_DA_0__0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'residua');
IS_PL_ID_0_asinh_0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'residua');
Correlation = ones([24, size(IS_PL_DA_0__0_g.residua, 3)]) .* -999;
P_values = ones([24, size(IS_PL_DA_0__0_g.residua, 3)]) .* -999;
fignum = 1;
for h = 1:24
    for i = 1:size(IS_PL_DA_0__0_g.residua, 3)
        [Correlation(h, i), P_values(h, i)] = corr(IS_PL_DA_0__0_g.residua(h, :, i)', IS_PL_ID_0_asinh_0_t.residua(h, :, i)');
    end
    figure(fignum)
    subplot(2,1,1)
    plot(Correlation(h, :))
    title("Pearson correlation")
    ylim([0,1])
    subplot(2,1,2)
    plot(P_values(h,:))
    title("p-values")
    fignum = fignum + 1;
end
