function l = se2(rv, cv)
    % Function calculates MSE2 loss function (result is a m x 1 vector)
    % VARIABLES
    % rv - realised variance, m x n
    % cv - conditional variance, m x n
    l = (rv - cv) .^ 2;
end
