addpath('Functions')
fignum  = 1;
alpha = 0.1;
%% GE DA
OOS_GE_DA_0_asinh1_1_g = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_DA_model_7_transformation_asinh1_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
IS_GE_DA_0_asinh1_0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
models_list = {OOS_GE_DA_0_asinh1_1_g.pinball,...
    IS_GE_DA_0_asinh1_0_g.pinball(:, 366:end, :)};
labels = {'OOS GE DA 0 asinh1 1 g',...
    'IS GE DA 0 asinh1 0 g'};
DM_cross_tests(models_list, labels, alpha)
% IS
%% GE ID
OOS_GE_ID_0_asinh1_1_g = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_ID_model_7_transformation_asinh1_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'prediction', 'real_value');
IS_GE_ID_0_asinh1_0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
models_list = {OOS_GE_ID_0_asinh1_1_g.pinball,...
    IS_GE_ID_0_asinh1_0_g.pinball(:, 366:end, :)};
labels = {'OOS GE ID 0 asinh1 1 g',...
    'IS GE ID 0 asinh1 0 g'};
DM_cross_tests(models_list, labels, alpha)
% IS
%% PL DA
OOS_PL_DA_0__0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
IS_DA_PL_DA_0__0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
models_list = {OOS_PL_DA_0__0_t.pinball,...
    IS_DA_PL_DA_0__0_t.pinball(:, 366:end, :)};
labels = {'OOS PL DA 0 0 t',...
    'IS PL DA 0 0 t'};
DM_cross_tests(models_list, labels, alpha)
% OOS
%% PL ID
OOS_PL_ID_0_asinh1_0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_PL_ID_model_7_transformation_asinh1_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'prediction', 'real_value');
IS_PL_ID_0_asinh_0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_PL_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly');
models_list = {OOS_PL_ID_0_asinh1_0_g.pinball,...
    IS_PL_ID_0_asinh_0_t.pinball(:, 366:end, :)};
labels = {'OOS PL ID 0 asinh1 0 g',...
    'IS PL DA 0 asinh 0 t'};
DM_cross_tests(models_list, labels, alpha)
% IS
