%% DA
% How to read the variables names? It is simple:
% DA_i_transformation_j_distribution, where
% i (0 or 1) - dynamic choice
% j (0 or 1) - MC if 1, hist. if 0
close all
DA_0__0_g_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__1_g_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_0_g_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value',  'prediction', 'samples_no_garch');
DA_0_asinh_1_g_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__0_t_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__1_t_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_0_t_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_1_t_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DA_0__0_g_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__1_g_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_0_g_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value',  'prediction', 'samples_no_garch');
DA_0_asinh_1_g_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__0_t_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__1_t_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_0_t_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_1_t_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
%% collecting models PS and their labels in a list
models_list = {DA_0__0_g_OOS.pinball, DA_0__1_g_OOS.pinball,... % gaussian GARCH(1,1)
    DA_0_asinh_0_g_OOS.pinball, DA_0_asinh_1_g_OOS.pinball,...
    DA_0__0_t_OOS.pinball, DA_0__1_t_OOS.pinball,... % t-Student GARCH(1,1,)
    DA_0_asinh_0_t_OOS.pinball, DA_0_asinh_1_t_OOS.pinball,...
    DA_0__0_g_GJR_OOS.pinball, DA_0__1_g_GJR_OOS.pinball,... % gaussian GARCH(1,1)
    DA_0_asinh_0_g_GJR_OOS.pinball, DA_0_asinh_1_g_GJR_OOS.pinball,...
    DA_0__0_t_GJR_OOS.pinball, DA_0__1_t_GJR_OOS.pinball,... % t-Student GARCH(1,1,)
    DA_0_asinh_0_t_GJR_OOS.pinball, DA_0_asinh_1_t_GJR_OOS.pinball,...
    DA_0__0_g_OOS.pinball_no_garch,... % without GARCH hist.
    DA_0__1_g_OOS.pinball_no_garch,... % without GARCH MC gaussian
    DA_0__1_t_OOS.pinball_no_garch,... % without GARCH MC t-Student
    DA_0_asinh_0_g_OOS.pinball_no_garch,... % without GARCH hist. asinh
    DA_0_asinh_1_g_OOS.pinball_no_garch,... % without GARCH MC gaussian asinh
    DA_0_asinh_1_t_OOS.pinball_no_garch}; % without GARCH MC t-Student asinh
labels = {'gaussian GARCH(1,1) hist.', 'gaussian GARCH(1,1) MC',...
    'gaussian GARCH(1,1) hist. asinh', 'gaussian GARCH(1,1) MC asinh',...
    't-Student GARCH(1,1) hist.', 't-Student GARCH(1,1) MC',...
    't-Student GARCH(1,1) hist. asinh', 't-Student GARCH(1,1) MC asinh',...
    'gaussian GJRGARCH(1,1) hist.', 'gaussian GJRGARCH(1,1) MC',...
    'gaussian GJRGARCH(1,1) hist. asinh', 'gaussian GJRGARCH(1,1) MC asinh',...
    't-Student GJRGARCH(1,1) hist.', 't-Student GJRGARCH(1,1) MC',...
    't-Student GJRGARCH(1,1) hist. asinh', 't-Student GJRGARCH(1,1) MC asinh',...
    'ARX hist.', 'gaussian ARX MC',...
    't-Student ARX MC', 'ARX hist. asinh',...
    'gaussian ARX MC asinh', 't-Student ARX MC asinh'
    };
%% PS means taken time wise vs quantiles
fignum = 1;
quantiles = 0.01:0.01:0.99;
please change x in for hour = 'x' to range or other hour to see results
for hour = 1:24
    figure(fignum)
    plotbrowser('on')
    hold on
    for m = 1:length(models_list)
        plot(quantiles, squeeze(mean(models_list{m}(hour, :, :), 2)))
    end
    hold off
    legend(labels, 'Location', 'best')
    fignum = fignum + 1;
end
%% PS means taken quantile wise and represented hourly
figure(fignum)
plotbrowser('on')
hold on
for m = 1:length(models_list)
    plot(mean(mean(models_list{m}(:, :, :), 2), 3))
end
hold off
legend(labels, 'Location', 'best')
fignum = fignum + 1;
%% PS means taken time wise hourly for 5, 10, 25, 50, 75, 90 and 95 percentile
for q = [5, 10, 25, 50, 75, 90, 95]
    figure(fignum)
    plotbrowser('on')
    hold on
    for m = 1:length(models_list)
        plot(mean(models_list{m}(:, :, q), 2))
    end
    hold off
    legend(labels, 'Location', 'best')
    title(num2str(quantiles(q)))
    fignum = fignum + 1;
end
%% PS D--M tests aggregated
close all
addpath('Functions')
alpha = 0.1;
% summing over 24 hours
count_matrice = zeros([length(models_list), length(models_list)]);
for i = 1:length(models_list)
    for j = 1:length(models_list)
        if i == j
            count_matrice(i,j) = NaN;
        end
    end
end
for hour = 1:24
    pvalmatyrice = ones([length(models_list), length(models_list)]);
    for m = 1:length(models_list)
        for n = 1:length(models_list)
            [DM, p] = dmtest(mean(models_list{m}(hour, :, :), 3)', mean(models_list{n}(hour, :, :), 3)');
            pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
        end
    end
    count = pvalmatyrice < alpha;
    count_matrice = count_matrice + count;
end
xvalues = labels;
yvalues = labels;
figure(fignum)
h = heatmap(xvalues, yvalues, count_matrice);
h.FontSize = 6;
caxis([0 24])
fignum = fignum + 1;
%% PS D--M test for chosen quantiles
for q = [5, 10, 25, 50, 75, 90, 95]
    % summing over 24 hours
    count_matrice = zeros([length(models_list), length(models_list)]);
    for i = 1:length(models_list)
        for j = 1:length(models_list)
            if i == j
                count_matrice(i,j) = NaN;
            end
        end
    end
    for hour = 1:24
        pvalmatyrice = ones([length(models_list), length(models_list)]);
        for m = 1:length(models_list)
            for n = 1:length(models_list)
                [DM, p] = dmtest(models_list{m}(hour, :, q)', models_list{n}(hour, :, q)');
                pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
            end
        end
        count = pvalmatyrice < alpha;
        count_matrice = count_matrice + count;
    end
    xvalues = labels;
    yvalues = labels;
    figure(fignum)
    h = heatmap(xvalues, yvalues, count_matrice);
    h.FontSize = 6;
    fignum = fignum + 1;
    title(['D--M, quantile ', num2str(quantiles(q))])
    fignum = fignum + 1;
end
%% MAE
curve
lin_models_list = {DA_0_asinh_0_g_OOS, DA_0__0_g_OOS};
labels_lin = {'ARX asinh', 'ARX'};
fignum = 1;
figure(fignum)
plotbrowser('on')
for m = 1:length(lin_models_list)
    plot(lin_models_list{m}.mae_hourly)
    hold on
end
% legend(labels_lin)
hold off
fignum = fignum + 1;
%% RMSE
curve
lin_models_list = {DA_0_asinh_0_g_OOS, DA_0__0_g_OOS};
labels_lin = {'ARX asinh', 'ARX'};
fignum = 2;
figure(fignum)
plotbrowser('on')
for m = 1:length(lin_models_list)
    plot(lin_models_list{m}.rmse_hourly)
    hold on
end
% legend(labels_lin)
hold off
fignum = fignum + 1;
%% D--M for point forecast errors ('RMSE' type)
summing over 24 hours
alpha = 0.1;
count_matrice = zeros([length(lin_models_list), length(lin_models_list)]);
for i = 1:length(lin_models_list)
    for j = 1:length(lin_models_list)
        if i == j
            count_matrice(i,j) = NaN;
        end
    end
end
for hour = 1:24
    pvalmatyrice = ones([length(lin_models_list), length(lin_models_list)]);
    for m = 1:length(lin_models_list)
        for n = 1:length(lin_models_list)
            e_1 = (lin_models_list{m}.real_value(hour, :) - lin_models_list{m}.prediction(hour, :)) .^ 2;
            e_2 = (lin_models_list{n}.real_value(hour, :) - lin_models_list{n}.prediction(hour, :)) .^ 2;
            [DM, p] = dmtest(e_1', e_2');
            pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
        end
    end
    count = pvalmatyrice < alpha;
    count_matrice = count_matrice + count;
end
xvalues = labels_lin;
yvalues = labels_lin;
figure(fignum)
h = heatmap(xvalues, yvalues, count_matrice);
h.FontSize = 6;
caxis([0 24])
%% PS means over hours vs quantiles
figure()
plotbrowser('on')
hold on
quantiles = 0.01:0.01:0.99;
for m = 1:length(models_list)
    plot(quantiles, squeeze(mean(mean(models_list{m}, 2))))
end
hold off
legend(labels, 'Location', 'best')
%% Comparison of IS and OOS point forecasts:
DA_0__0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__1_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value',  'prediction', 'samples_no_garch');
DA_0_asinh_1_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__1_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_1_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DA_0__0_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__1_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_0_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value',  'prediction', 'samples_no_garch');
DA_0_asinh_1_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__0_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0__1_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_DA_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_0_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
DA_0_asinh_1_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_DA_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction', 'samples_no_garch');
models_list_IS_prediction = {DA_0__0_g.prediction, DA_0__1_g.prediction,... % gaussian GARCH(1,1)
    DA_0_asinh_0_g.prediction, DA_0_asinh_1_g.prediction,...
    DA_0__0_t.prediction, DA_0__1_t.prediction,... % t-Student GARCH(1,1,)
    DA_0_asinh_0_t.prediction, DA_0_asinh_1_t.prediction,...
    DA_0__0_g_GJR.prediction, DA_0__1_g_GJR.prediction,... % gaussian GARCH(1,1)
    DA_0_asinh_0_g_GJR.prediction, DA_0_asinh_1_g_GJR.prediction,...
    DA_0__0_t_GJR.prediction, DA_0__1_t_GJR.prediction,... % t-Student GARCH(1,1,)
    DA_0_asinh_0_t_GJR.prediction, DA_0_asinh_1_t_GJR.prediction}; % without GARCH MC t-Student asinh
models_list_OOS_prediction = {DA_0__0_g_OOS.prediction, DA_0__1_g_OOS.prediction,... % gaussian GARCH(1,1)
    DA_0_asinh_0_g_OOS.prediction, DA_0_asinh_1_g_OOS.prediction,...
    DA_0__0_t_OOS.prediction, DA_0__1_t_OOS.prediction,... % t-Student GARCH(1,1,)
    DA_0_asinh_0_t_OOS.prediction, DA_0_asinh_1_t_OOS.prediction,...
    DA_0__0_g_GJR_OOS.prediction, DA_0__1_g_GJR_OOS.prediction,... % gaussian GARCH(1,1)
    DA_0_asinh_0_g_GJR_OOS.prediction, DA_0_asinh_1_g_GJR_OOS.prediction,...
    DA_0__0_t_GJR_OOS.prediction, DA_0__1_t_GJR_OOS.prediction,... % t-Student GARCH(1,1,)
    DA_0_asinh_0_t_GJR_OOS.prediction, DA_0_asinh_1_t_GJR_OOS.prediction}; % without GARCH MC t-Student asinh
%%
% for m = 1:length(models_list_OOS_prediction)
%     disp([labels{m}, ' ', num2str(isequal(models_list_IS_prediction{m}(:, 366:end), models_list_OOS_prediction{m}))])
%     if m >= 2
%         disp(['IS: ', labels{m}, ' vs ', labels{m - 1}, ' ', num2str(isequal(models_list_IS_prediction{m}, models_list_IS_prediction{m - 1}))])
%         disp(['OOS: ', labels{m}, ' vs ', labels{m - 1}, ' ', num2str(isequal(models_list_OOS_prediction{m}, models_list_OOS_prediction{m - 1}))])
%     end
% end
%% comparison of prediction errors between OOS and IS
models_list_IS_prediction = {DA_0_asinh_0_g.prediction, DA_0_asinh_1_g.prediction,...
    DA_0_asinh_0_t.prediction, DA_0_asinh_1_t.prediction,...
    DA_0_asinh_0_g_GJR.prediction, DA_0_asinh_1_g_GJR.prediction,...
    DA_0_asinh_0_t_GJR.prediction, DA_0_asinh_1_t_GJR.prediction}; % without GARCH MC t-Student asinh
models_list_OOS_prediction = {DA_0_asinh_0_g_OOS.prediction, DA_0_asinh_1_g_OOS.prediction,...
    DA_0_asinh_0_t_OOS.prediction, DA_0_asinh_1_t_OOS.prediction,...
    DA_0_asinh_0_g_GJR_OOS.prediction, DA_0_asinh_1_g_GJR_OOS.prediction,...
    DA_0_asinh_0_t_GJR_OOS.prediction, DA_0_asinh_1_t_GJR_OOS.prediction}; % without GARCH MC t-Student asinh
models_list_IS_realval = {DA_0_asinh_0_g.real_value, DA_0_asinh_1_g.real_value,...
    DA_0_asinh_0_t.real_value, DA_0_asinh_1_t.real_value,...
    DA_0_asinh_0_g_GJR.real_value, DA_0_asinh_1_g_GJR.real_value,...
    DA_0_asinh_0_t_GJR.real_value, DA_0_asinh_1_t_GJR.real_value}; % without GARCH MC t-Student asinh
models_list_OOS_realval = {DA_0_asinh_0_g_OOS.real_value, DA_0_asinh_1_g_OOS.real_value,...
    DA_0_asinh_0_t_OOS.real_value, DA_0_asinh_1_t_OOS.real_value,...
    DA_0_asinh_0_g_GJR_OOS.real_value, DA_0_asinh_1_g_GJR_OOS.real_value,...
    DA_0_asinh_0_t_GJR_OOS.real_value, DA_0_asinh_1_t_GJR_OOS.real_value}; % without GARCH MC t-Student asinh
labels_asinh = {'gaussian GARCH(1,1) hist. asinh', 'gaussian GARCH(1,1) MC asinh',...
    't-Student GARCH(1,1) hist. asinh', 't-Student GARCH(1,1) MC asinh',...
    'gaussian GJRGARCH(1,1) hist. asinh', 'gaussian GJRGARCH(1,1) MC asinh',...
    't-Student GJRGARCH(1,1) hist. asinh', 't-Student GJRGARCH(1,1) MC asinh'
    };
%% Comparison of forecast error mean over hours
% for m = 1:length(models_list_OOS_prediction)
%     figure(fignum)
%     histogram(mean(models_list_IS_realval{m}(:, 366:end) - models_list_IS_prediction{m}(:, 366:end)), 'BinMethod', 'scott', 'Normalization', 'pdf')
%     hold on
%     histogram(mean(models_list_OOS_realval{m} - models_list_OOS_prediction{m}), 'BinMethod', 'scott', 'Normalization', 'pdf')
%     hold off
%     title(labels_asinh{m})
%     disp([labels_asinh{m}, ' ', num2str(isequal(models_list_IS_realval{m}(:, 366:end), models_list_OOS_realval{m}))])
%     ttest2(mean(models_list_IS_realval{m}(:, 366:end) - models_list_IS_prediction{m}(:, 366:end)),...
%         mean(models_list_OOS_realval{m} - models_list_OOS_prediction{m}))
%     ttest2(mean(models_list_IS_realval{m}(:, 366:end) - models_list_IS_prediction{m}(:, 366:end)),...
%         mean(models_list_OOS_realval{m} - models_list_OOS_prediction{m}),'Vartype','unequal')
%     fignum = fignum + 1;
% end
%% Comparison of forecast errors for every hour
for m = 1:length(models_list_OOS_prediction)
    for h = 1:24
%         figure(fignum)
%         histogram(models_list_IS_realval{m}(h, 366:end) - models_list_IS_prediction{m}(h, 366:end), 'BinMethod', 'scott', 'Normalization', 'pdf')
%         hold on
%         histogram(models_list_OOS_realval{m}(h, :) - models_list_OOS_prediction{m}(h, :), 'BinMethod', 'scott', 'Normalization', 'pdf')
%         hold off
%         legend('IS', 'OOS')
%         title(['Hour ', num2str(h), ' model ', labels_asinh{m}])
%         fig=gcf;
%         fig.Position(3:4)=[600, 700];
        % testing the means equality:
        [dec_1, p_1] = ttest2(models_list_IS_realval{m}(h, 366:end) - models_list_IS_prediction{m}(h, 366:end),...
            models_list_OOS_realval{m}(h, :) - models_list_OOS_prediction{m}(h, :));
        [dec_2, p_2] = ttest2(models_list_IS_realval{m}(h, 366:end) - models_list_IS_prediction{m}(h, 366:end),...
            models_list_OOS_realval{m}(h, :) - models_list_OOS_prediction{m}(h, :),'Vartype','unequal');
        % testing the distributions:
        [dec_3, p_3] = kstest2(models_list_IS_realval{m}(h, 366:end) - models_list_IS_prediction{m}(h, 366:end),...
            models_list_OOS_realval{m}(h, :) - models_list_OOS_prediction{m}(h, :), 'Tail', 'smaller');
        if dec_1 == 1 || dec_2 == 1 || dec_3 == 1
            disp([labels_asinh{m}, ' ', num2str(p_1), ' ', num2str(p_2), ' ', num2str(p_3), ' ', num2str(h)])
        end
        fignum = fignum + 1;
    end
end
%% comparison of samples no garch
models_list_IS_samples_no_garch = {DA_0_asinh_0_g.samples_no_garch};%, DA_0_asinh_1_g.samples_no_garch,...
%     DA_0_asinh_0_t.samples_no_garch, DA_0_asinh_1_t.samples_no_garch,...
%     DA_0_asinh_0_g_GJR.samples_no_garch, DA_0_asinh_1_g_GJR.samples_no_garch,...
%     DA_0_asinh_0_t_GJR.samples_no_garch, DA_0_asinh_1_t_GJR.samples_no_garch}; % without GARCH MC t-Student asinh
models_list_OOS_samples_no_garch = {DA_0_asinh_0_g_OOS.samples_no_garch};%, DA_0_asinh_1_g_OOS.samples_no_garch,...
%     DA_0_asinh_0_t_OOS.samples_no_garch, DA_0_asinh_1_t_OOS.samples_no_garch,...
%     DA_0_asinh_0_g_GJR_OOS.samples_no_garch, DA_0_asinh_1_g_GJR_OOS.samples_no_garch,...
%     DA_0_asinh_0_t_GJR_OOS.samples_no_garch, DA_0_asinh_1_t_GJR_OOS.samples_no_garch}; % without GARCH MC t-Student asinh
labels_asinh = {'gaussian GARCH(1,1) hist. asinh'};%, 'gaussian GARCH(1,1) MC asinh',...
%     't-Student GARCH(1,1) hist. asinh', 't-Student GARCH(1,1) MC asinh',...
%     'gaussian GJRGARCH(1,1) hist. asinh', 'gaussian GJRGARCH(1,1) MC asinh',...
%     't-Student GJRGARCH(1,1) hist. asinh', 't-Student GJRGARCH(1,1) MC asinh'
%     };
fignum = 1;
t = datetime('2017-01-01') + caldays(373 + 365) + caldays(0:722);
data = importdata('../Data/data_Germany_20170101_20201231.txt');
for m = 1:length(models_list_IS_samples_no_garch)
    for h = 1:24
        solar = data(h:24:end, 8);
        wind = data(h:24:end, 7);
        % testing the means equality:
        [dec_1, p_1] = ttest2(models_list_IS_samples_no_garch{m}(h, :, 366:end),...
            models_list_OOS_samples_no_garch{m}(h, :, :));
        [dec_2, p_2] = ttest2(models_list_IS_samples_no_garch{m}(h, :, 366:end),...
            models_list_OOS_samples_no_garch{m}(h, :, :), 'Vartype','unequal');
        % testing the distributions:
        kstest_results = ones(1, 723) .* -999;
        for i = 1:723
            [dec_3, p_3] = kstest2(models_list_IS_samples_no_garch{m}(h, :, 365 + i),...
                models_list_OOS_samples_no_garch{m}(h, :, i));
            kstest_results(i) = p_3;
        end
        figure(fignum)
        plot(t, p_1(:))
        hold on
        plot(t, p_2(:))
        plot(t, kstest_results)
        plot(solar(end - 723:end) ./ max(solar(end - 723:end)))
%         plot(wind(end - 723:end) ./ max(wind(end - 723:end)))
        yline(0.05, 'color', 'black')
        hold off
        legend('ttest2_1', 'ttest2_2', 'kstest2', 'solar', 'wind')
        title(['Hour ', num2str(h), ' model ', labels_asinh{m}])
%         fig=gcf;
%         fig.Position(3:4)=[500, 400];
%         if dec_1 == 1 || dec_2 == 1 || dec_3 == 1
%             disp([labels_asinh{m}, ' ', num2str(p_1), ' ', num2str(p_2), ' ', num2str(p_3), ' ', num2str(h)])
%         end
        fignum = fignum + 1;
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% ID
close all
ID_0__0_g_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__1_g_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_0_g_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value',  'prediction');
ID_0_asinh_1_g_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__0_t_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__1_t_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_0_t_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_1_t_OOS = load('../../../Data_MATLAB_Drive/Data/GARCH_OOS_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ID_0__0_g_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__1_g_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_0_g_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value',  'prediction');
ID_0_asinh_1_g_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__0_t_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__1_t_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_0_t_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_1_t_GJR_OOS = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_OOS_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
%% collecting models PS and their labels in a list
models_list = {ID_0__0_g_OOS.pinball, ID_0__1_g_OOS.pinball,... % gaussian GARCH(1,1)
    ID_0_asinh_0_g_OOS.pinball, ID_0_asinh_1_g_OOS.pinball,...
    ID_0__0_t_OOS.pinball, ID_0__1_t_OOS.pinball,... % t-Student GARCH(1,1,)
    ID_0_asinh_0_t_OOS.pinball, ID_0_asinh_1_t_OOS.pinball,...
    ID_0__0_g_GJR_OOS.pinball, ID_0__1_g_GJR_OOS.pinball,... % gaussian GARCH(1,1)
    ID_0_asinh_0_g_GJR_OOS.pinball, ID_0_asinh_1_g_GJR_OOS.pinball,...
    ID_0__0_t_GJR_OOS.pinball, ID_0__1_t_GJR_OOS.pinball,... % t-Student GARCH(1,1,)
    ID_0_asinh_0_t_GJR_OOS.pinball, ID_0_asinh_1_t_GJR_OOS.pinball,...
    ID_0__0_g_OOS.pinball_no_garch,... % without GARCH hist.
    ID_0__1_g_OOS.pinball_no_garch,... % without GARCH MC gaussian
    ID_0__1_t_OOS.pinball_no_garch,... % without GARCH MC t-Student
    ID_0_asinh_0_g_OOS.pinball_no_garch,... % without GARCH hist. asinh
    ID_0_asinh_1_g_OOS.pinball_no_garch,... % without GARCH MC gaussian asinh
    ID_0_asinh_1_t_OOS.pinball_no_garch}; % without GARCH MC t-Student asinh
labels = {'gaussian GARCH(1,1) hist.', 'gaussian GARCH(1,1) MC',...
    'gaussian GARCH(1,1) hist. asinh', 'gaussian GARCH(1,1) MC asinh',...
    't-Student GARCH(1,1) hist.', 't-Student GARCH(1,1) MC',...
    't-Student GARCH(1,1) hist. asinh', 't-Student GARCH(1,1) MC asinh',...
    'gaussian GJRGARCH(1,1) hist.', 'gaussian GJRGARCH(1,1) MC',...
    'gaussian GJRGARCH(1,1) hist. asinh', 'gaussian GJRGARCH(1,1) MC asinh',...
    't-Student GJRGARCH(1,1) hist.', 't-Student GJRGARCH(1,1) MC',...
    't-Student GJRGARCH(1,1) hist. asinh', 't-Student GJRGARCH(1,1) MC asinh',...
    'ARX hist.', 'gaussian ARX MC',...
    't-Student ARX MC', 'ARX hist. asinh',...
    'gaussian ARX MC asinh', 't-Student ARX MC asinh'
    };
%% PS means taken time wise vs quantiles
fignum = 1;
quantiles = 0.01:0.01:0.99;
% please change x in for hour = 'x' to range or other hour to see results
for hour = 1:24
    figure(fignum)
    plotbrowser('on')
    hold on
    for m = 1:length(models_list)
        plot(quantiles, squeeze(mean(models_list{m}(hour, :, :), 2)))
    end
    hold off
    legend(labels, 'Location', 'best')
    fignum = fignum + 1;
end
%% PS means taken quantile wise and represented hourly
figure(fignum)
plotbrowser('on')
hold on
for m = 1:length(models_list)
    plot(mean(mean(models_list{m}(:, :, :), 2), 3))
end
hold off
legend(labels, 'Location', 'best')
fignum = fignum + 1;
%% PS means taken time wise hourly for 5, 10, 25, 50, 75, 90 and 95 percentile
for q = [5, 10, 25, 50, 75, 90, 95]
    figure(fignum)
    plotbrowser('on')
    hold on
    for m = 1:length(models_list)
        plot(mean(models_list{m}(:, :, q), 2))
    end
    hold off
    legend(labels, 'Location', 'best')
    title(num2str(quantiles(q)))
    fignum = fignum + 1;
end
%% PS D--M tests aggregated
close all
addpath('Functions')
alpha = 0.1;
% summing over 24 hours
count_matrice = zeros([length(models_list), length(models_list)]);
for i = 1:length(models_list)
    for j = 1:length(models_list)
        if i == j
            count_matrice(i,j) = NaN;
        end
    end
end
for hour = 1:24
    pvalmatyrice = ones([length(models_list), length(models_list)]);
    for m = 1:length(models_list)
        for n = 1:length(models_list)
            [DM, p] = dmtest(mean(models_list{m}(hour, :, :), 3)', mean(models_list{n}(hour, :, :), 3)');
            pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
        end
    end
    count = pvalmatyrice < alpha;
    count_matrice = count_matrice + count;
end
xvalues = labels;
yvalues = labels;
figure(fignum)
h = heatmap(xvalues, yvalues, count_matrice);
h.FontSize = 6;
caxis([0 24])
fignum = fignum + 1;
%% PS D--M test for chosen quantiles
for q = [5, 10, 25, 50, 75, 90, 95]
    % summing over 24 hours
    count_matrice = zeros([length(models_list), length(models_list)]);
    for i = 1:length(models_list)
        for j = 1:length(models_list)
            if i == j
                count_matrice(i,j) = NaN;
            end
        end
    end
    for hour = 1:24
        pvalmatyrice = ones([length(models_list), length(models_list)]);
        for m = 1:length(models_list)
            for n = 1:length(models_list)
                [DM, p] = dmtest(models_list{m}(hour, :, q)', models_list{n}(hour, :, q)');
                pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
            end
        end
        count = pvalmatyrice < alpha;
        count_matrice = count_matrice + count;
    end
    xvalues = labels;
    yvalues = labels;
    figure(fignum)
    h = heatmap(xvalues, yvalues, count_matrice);
    h.FontSize = 6;
    fignum = fignum + 1;
    title(['D--M, quantile ', num2str(quantiles(q))])
    fignum = fignum + 1;
end
%% Median
lin_models_list = {ID_0_asinh_0_g_OOS, ID_0__0_g_OOS};
labels_lin = {'ARX asinh', 'ARX'};
fignum = 1;
figure(fignum)
plotbrowser('on')
for m = 1:length(lin_models_list)
    plot(median(abs(lin_models_list{m}.real_value - lin_models_list{m}.prediction), 2))
    hold on
end
% legend(labels_lin)
hold off
fignum = fignum + 1;
%% MAE
% curve
lin_models_list = {ID_0_asinh_0_g_OOS, ID_0__0_g_OOS};
labels_lin = {'ARX asinh', 'ARX'};
fignum = 1;
figure(fignum)
plotbrowser('on')
for m = 1:length(lin_models_list)
    plot(lin_models_list{m}.mae_hourly)
    hold on
end
% legend(labels_lin)
hold off
fignum = fignum + 1;
%% RMSE
% curve
lin_models_list = {ID_0_asinh_0_g_OOS, ID_0__0_g_OOS};
labels_lin = {'ARX asinh', 'ARX'};
fignum = 2;
figure(fignum)
plotbrowser('on')
for m = 1:length(lin_models_list)
    plot(lin_models_list{m}.rmse_hourly)
    hold on
end
% legend(labels_lin)
hold off
fignum = fignum + 1;
%% D--M for point forecast errors ('RMSE' type)
% summing over 24 hours
alpha = 0.1;
count_matrice = zeros([length(lin_models_list), length(lin_models_list)]);
for i = 1:length(lin_models_list)
    for j = 1:length(lin_models_list)
        if i == j
            count_matrice(i,j) = NaN;
        end
    end
end
for hour = 1:24
    pvalmatyrice = ones([length(lin_models_list), length(lin_models_list)]);
    for m = 1:length(lin_models_list)
        for n = 1:length(lin_models_list)
            e_1 = (lin_models_list{m}.real_value(hour, :) - lin_models_list{m}.prediction(hour, :)) .^ 2;
            e_2 = (lin_models_list{n}.real_value(hour, :) - lin_models_list{n}.prediction(hour, :)) .^ 2;
            [DM, p] = dmtest(e_1', e_2');
            pvalmatyrice(n, m) = p; % model on y is worse than model on x if p-value < alpha (alpha = 0.1)
        end
    end
    count = pvalmatyrice < alpha;
    count_matrice = count_matrice + count;
end
xvalues = labels_lin;
yvalues = labels_lin;
figure(fignum)
h = heatmap(xvalues, yvalues, count_matrice);
h.FontSize = 6;
s = struct(h);
s.XAxis.TickLabelRotation = 90;  % vertical
caxis([0 24])
%% PS means over hours vs quantiles
figure()
plotbrowser('on')
hold on
quantiles = 0.01:0.01:0.99;
for m = 1:length(models_list)
    plot(quantiles, squeeze(mean(mean(models_list{m}, 2))))
end
hold off
legend(labels, 'Location', 'best')
%% Comparison of IS and OOS point forecasts:
ID_0__0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__1_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_0_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value',  'prediction');
ID_0_asinh_1_g = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__1_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_0_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_1_t = load('../../../Data_MATLAB_Drive/Data/GARCH_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ID_0__0_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__1_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_0_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value',  'prediction');
ID_0_asinh_1_g_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_g.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__0_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0__1_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_ID_model_7_transformation__dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_0_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_0_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
ID_0_asinh_1_t_GJR = load('../../../Data_MATLAB_Drive/Data/GJRGARCH_simulation_results_GE_ID_model_7_transformation_asinh_dynamic_choice_0_mc_1_dist_t.mat',...
    'pinball', 'pinball_no_garch', 'mae_hourly', 'rmse_hourly', 'real_value', 'prediction');
models_list_IS_prediction = {ID_0__0_g.prediction, ID_0__1_g.prediction,... % gaussian GARCH(1,1)
    ID_0_asinh_0_g.prediction, ID_0_asinh_1_g.prediction,...
    ID_0__0_t.prediction, ID_0__1_t.prediction,... % t-Student GARCH(1,1,)
    ID_0_asinh_0_t.prediction, ID_0_asinh_1_t.prediction,...
    ID_0__0_g_GJR.prediction, ID_0__1_g_GJR.prediction,... % gaussian GARCH(1,1)
    ID_0_asinh_0_g_GJR.prediction, ID_0_asinh_1_g_GJR.prediction,...
    ID_0__0_t_GJR.prediction, ID_0__1_t_GJR.prediction,... % t-Student GARCH(1,1,)
    ID_0_asinh_0_t_GJR.prediction, ID_0_asinh_1_t_GJR.prediction}; % without GARCH MC t-Student asinh
models_list_OOS_prediction = {ID_0__0_g_OOS.prediction, ID_0__1_g_OOS.prediction,... % gaussian GARCH(1,1)
    ID_0_asinh_0_g_OOS.prediction, ID_0_asinh_1_g_OOS.prediction,...
    ID_0__0_t_OOS.prediction, ID_0__1_t_OOS.prediction,... % t-Student GARCH(1,1,)
    ID_0_asinh_0_t_OOS.prediction, ID_0_asinh_1_t_OOS.prediction,...
    ID_0__0_g_GJR_OOS.prediction, ID_0__1_g_GJR_OOS.prediction,... % gaussian GARCH(1,1)
    ID_0_asinh_0_g_GJR_OOS.prediction, ID_0_asinh_1_g_GJR_OOS.prediction,...
    ID_0__0_t_GJR_OOS.prediction, ID_0__1_t_GJR_OOS.prediction,... % t-Student GARCH(1,1,)
    ID_0_asinh_0_t_GJR_OOS.prediction, ID_0_asinh_1_t_GJR_OOS.prediction}; % without GARCH MC t-Student asinh
%%
for m = 1:length(models_list_OOS_prediction)
    disp([labels{m}, ' ', num2str(isequal(models_list_IS_prediction{m}(:, 366:end), models_list_OOS_prediction{m}))])
    disp([labels{m}, ' ', num2str(isequal(models_list_IS_prediction{m}(:, 366:end), models_list_OOS_prediction{m}))])
    if m >= 2
        disp(['IS: ', labels{m}, ' vs ', labels{m - 1}, ' ', num2str(isequal(models_list_IS_prediction{m}, models_list_IS_prediction{m - 1}))])
        disp(['OOS: ', labels{m}, ' vs ', labels{m - 1}, ' ', num2str(isequal(models_list_OOS_prediction{m}, models_list_OOS_prediction{m - 1}))])
    end
end
%% comparison of prediction errors between OOS and IS
models_list_IS_prediction = {ID_0_asinh_0_g.prediction, ID_0_asinh_1_g.prediction,...
    ID_0_asinh_0_t.prediction, ID_0_asinh_1_t.prediction,...
    ID_0_asinh_0_g_GJR.prediction, ID_0_asinh_1_g_GJR.prediction,...
    ID_0_asinh_0_t_GJR.prediction, ID_0_asinh_1_t_GJR.prediction}; % without GARCH MC t-Student asinh
models_list_OOS_prediction = {ID_0_asinh_0_g_OOS.prediction, ID_0_asinh_1_g_OOS.prediction,...
    ID_0_asinh_0_t_OOS.prediction, ID_0_asinh_1_t_OOS.prediction,...
    ID_0_asinh_0_g_GJR_OOS.prediction, ID_0_asinh_1_g_GJR_OOS.prediction,...
    ID_0_asinh_0_t_GJR_OOS.prediction, ID_0_asinh_1_t_GJR_OOS.prediction}; % without GARCH MC t-Student asinh
models_list_IS_realval = {ID_0_asinh_0_g.real_value, ID_0_asinh_1_g.real_value,...
    ID_0_asinh_0_t.real_value, ID_0_asinh_1_t.real_value,...
    ID_0_asinh_0_g_GJR.real_value, ID_0_asinh_1_g_GJR.real_value,...
    ID_0_asinh_0_t_GJR.real_value, ID_0_asinh_1_t_GJR.real_value}; % without GARCH MC t-Student asinh
models_list_OOS_realval = {ID_0_asinh_0_g_OOS.real_value, ID_0_asinh_1_g_OOS.real_value,...
    ID_0_asinh_0_t_OOS.real_value, ID_0_asinh_1_t_OOS.real_value,...
    ID_0_asinh_0_g_GJR_OOS.real_value, ID_0_asinh_1_g_GJR_OOS.real_value,...
    ID_0_asinh_0_t_GJR_OOS.real_value, ID_0_asinh_1_t_GJR_OOS.real_value}; % without GARCH MC t-Student asinh
labels_asinh = {'gaussian GARCH(1,1) hist. asinh', 'gaussian GARCH(1,1) MC asinh',...
    't-Student GARCH(1,1) hist. asinh', 't-Student GARCH(1,1) MC asinh',...
    'gaussian GJRGARCH(1,1) hist. asinh', 'gaussian GJRGARCH(1,1) MC asinh',...
    't-Student GJRGARCH(1,1) hist. asinh', 't-Student GJRGARCH(1,1) MC asinh'
    };
%% Comparison of forecast error mean over hours
for m = 1:length(models_list_OOS_prediction)
    figure(fignum)
    histogram(mean(models_list_IS_realval{m}(:, 366:end) - models_list_IS_prediction{m}(:, 366:end)), 'BinMethod', 'scott', 'Normalization', 'pdf')
    hold on
    histogram(mean(models_list_OOS_realval{m} - models_list_OOS_prediction{m}), 'BinMethod', 'scott', 'Normalization', 'pdf')
    hold off
    title(labels_asinh{m})
    disp([labels_asinh{m}, ' ', num2str(isequal(models_list_IS_realval{m}(:, 366:end), models_list_OOS_realval{m}))])
    ttest2(mean(models_list_IS_realval{m}(:, 366:end) - models_list_IS_prediction{m}(:, 366:end)),...
        mean(models_list_OOS_realval{m} - models_list_OOS_prediction{m}))
    ttest2(mean(models_list_IS_realval{m}(:, 366:end) - models_list_IS_prediction{m}(:, 366:end)),...
        mean(models_list_OOS_realval{m} - models_list_OOS_prediction{m}),'Vartype','unequal')
    fignum = fignum + 1;
end
%% Comparison of forecast errors for every hour
for m = 1:length(models_list_OOS_prediction)
    for h = 1:24
        figure(fignum)
        histogram(models_list_IS_realval{m}(h, 366:end) - models_list_IS_prediction{m}(h, 366:end), 'BinMethod', 'scott', 'Normalization', 'pdf')
        hold on
        histogram(models_list_OOS_realval{m}(h, :) - models_list_OOS_prediction{m}(h, :), 'BinMethod', 'scott', 'Normalization', 'pdf')
        hold off
        legend('IS', 'OOS')
        title(['Hour ', num2str(h), ' model ', labels_asinh{m}])
        fig=gcf;
        fig.Position(3:4)=[600, 700];
        % testing the means equality:
        [dec_1, p_1] = ttest2(models_list_IS_realval{m}(h, 366:end) - models_list_IS_prediction{m}(h, 366:end),...
            models_list_OOS_realval{m}(h, :) - models_list_OOS_prediction{m}(h, :));
        [dec_2, p_2] = ttest2(models_list_IS_realval{m}(h, 366:end) - models_list_IS_prediction{m}(h, 366:end),...
            models_list_OOS_realval{m}(h, :) - models_list_OOS_prediction{m}(h, :),'Vartype','unequal');
        % testing the distributions:
        [dec_3, p_3] = kstest2(models_list_IS_realval{m}(h, 366:end) - models_list_IS_prediction{m}(h, 366:end),...
            models_list_OOS_realval{m}(h, :) - models_list_OOS_prediction{m}(h, :), 'Tail', 'smaller');
        if dec_1 == 1 || dec_2 == 1 || dec_3 == 1
            disp([labels_asinh{m}, ' ', num2str(p_1), ' ', num2str(p_2), ' ', num2str(p_3), ' ', num2str(h)])
        end
        fignum = fignum + 1;
    end
end